HDU 1385 Minimum Transport Cost (Floyd求最短路径+记录字典序路径)

来源:互联网 发布:怎样在淘宝用网银卡 编辑:程序博客网 时间:2024/05/17 01:06

Minimum Transport Cost

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 5340    Accepted Submission(s): 1338


Problem Description
These are N cities in Spring country. Between each pair of cities there may be one transportation track or none. Now there is some cargo that should be delivered from one city to another. The transportation fee consists of two parts:
The cost of the transportation on the path between these cities, and

a certain tax which will be charged whenever any cargo passing through one city, except for the source and the destination cities.

You must write a program to find the route which has the minimum cost.
 

Input
First is N, number of cities. N = 0 indicates the end of input.

The data of path cost, city tax, source and destination cities are given in the input, which is of the form:

a11 a12 ... a1N
a21 a22 ... a2N
...............
aN1 aN2 ... aNN
b1 b2 ... bN

c d
e f
...
g h

where aij is the transport cost from city i to city j, aij = -1 indicates there is no direct path between city i and city j. bi represents the tax of passing through city i. And the cargo is to be delivered from city c to city d, city e to city f, ..., and g = h = -1. You must output the sequence of cities passed by and the total cost which is of the form:
 

Output
From c to d :
Path: c-->c1-->......-->ck-->d
Total cost : ......
......

From e to f :
Path: e-->e1-->..........-->ek-->f
Total cost : ......

Note: if there are more minimal paths, output the lexically smallest one. Print a blank line after each test case.

 

Sample Input
5
0 3 22 -1 4
3 0 5 -1 -1
22 5 0 9 20
-1 -1 9 0 4
4 -1 20 4 0
5 17 8 3 1
1 3
3 5
2 4
-1 -1
0

Sample Output
From 1 to 3 :
Path: 1-->5-->4-->3
Total cost : 21

From 3 to 5 :
Path: 3-->4-->5
Total cost : 16

From 2 to 4 :
Path: 2-->1-->5-->4
Total cost : 17

题意说的是给一个地图,询问N次某起点到某终点的最短路径,其中除了起点和终点外,经过的中间点要交税。

多源最短路径自然用floyd比较方便,而且floyd记录路径也很简单。定义路径path[i][j]表示的是以i为起点,j为终点时,i首先经过了哪个点。因此,很明显path[i][j]初始化为j。因为一开始是默认i可以直接到达j,自然i第一个经过的点是j。对于交税,只需在松弛的时候添加多个税收费用,对于字典序,则在松弛时,如果遇到相当的情况就判断字典序,既cnt[j][k] == cnt[j][i]+cnt[i][k]+tax[i]时,取path[j][k]和path[j][i]的最小值。根据path的定义,假如j~k为j-a-....-k,同时j-i-k为j-b-....-i-....k,故此时判断的是a和b的大小。

 

#include <iostream>#include <cstring>#include <cstdio>#include <algorithm>#define SIZE 1005#define inf 0xfffffffusing namespace std;int N;int cnt[SIZE][SIZE],path[SIZE][SIZE],tax[SIZE];void floyd(){for(int i=1; i<=N; i++){for(int j=1; j<=N; j++){for(int k=1; k<=N; k++){if(cnt[j][k] > cnt[j][i] + cnt[i][k] + tax[i]){cnt[j][k] = cnt[j][i] + cnt[i][k] + tax[i];path[j][k] = path[j][i];}else if(cnt[j][k] == cnt[j][i] + cnt[i][k] + tax[i]){if(path[j][k] > path[j][i])path[j][k] = path[j][i];}}}}}void print(int s,int e){printf("From %d to %d :\n",s,e);printf("Path: %d",s);int temp = path[s][e];while(temp != e){printf("-->%d",temp);temp = path[temp][e];}if(s != e)    printf("-->%d\n",e);elseprintf("\n");printf("Total cost : %d\n",cnt[s][e]);}int main(){while(~scanf("%d",&N) && N){for(int i=1; i<=N; i++){for(int j=1; j<=N; j++){scanf("%d",&cnt[i][j]);if(cnt[i][j] == -1)cnt[i][j] = inf;path[i][j] =j;}}for(int i=1; i<=N; i++)scanf("%d",&tax[i]);floyd();int s,e;while(scanf("%d%d",&s,&e)){if(s == -1 && e == -1)break;print(s,e);printf("\n");}}return 0;}


 

原创粉丝点击